/*
 * Copyright © Stéphane Raimbault <stephane.raimbault@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef UNIPICHANNEL_VERSION_H
#define UNIPICHANNEL_VERSION_H

/* The major version, (1, if %LIBUNIPICHANNEL_VERSION is 1.2.3) */
#define LIBUNIPICHANNEL_VERSION_MAJOR (@LIBUNIPICHANNEL_VERSION_MAJOR@)

/* The minor version (2, if %LIBUNIPICHANNEL_VERSION is 1.2.3) */
#define LIBUNIPICHANNEL_VERSION_MINOR (@LIBUNIPICHANNEL_VERSION_MINOR@)

/* The micro version (3, if %LIBUNIPICHANNEL_VERSION is 1.2.3) */
#define LIBUNIPICHANNEL_VERSION_MICRO (@LIBUNIPICHANNEL_VERSION_MICRO@)

/* The full version, like 1.2.3 */
#define LIBUNIPICHANNEL_VERSION `git describe --tags --always --abbrev=6 || head -1 version || echo 2.18.0`

/* The full version, in string form (suited for string concatenation)
 */
#define LIBUNIPICHANNEL_VERSION_STRING "`git describe --tags --always --abbrev=6 || head -1 version || echo 2.18.0`"

/* Numerically encoded version, eg. v1.2.3 is 0x010203 */
#define LIBUNIPICHANNEL_VERSION_HEX                                                                      \
    ((LIBUNIPICHANNEL_VERSION_MAJOR << 16) | (LIBUNIPICHANNEL_VERSION_MINOR << 8) |                            \
     (LIBUNIPICHANNEL_VERSION_MICRO << 0))

/* Evaluates to True if the version is greater than @major, @minor and @micro
 */
#define LIBUNIPICHANNEL_VERSION_CHECK(major, minor, micro)                                               \
    (LIBUNIPICHANNEL_VERSION_MAJOR > (major) ||                                                          \
     (LIBUNIPICHANNEL_VERSION_MAJOR == (major) && LIBUNIPICHANNEL_VERSION_MINOR > (minor)) ||                  \
     (LIBUNIPICHANNEL_VERSION_MAJOR == (major) && LIBUNIPICHANNEL_VERSION_MINOR == (minor) &&                  \
      LIBUNIPICHANNEL_VERSION_MICRO >= (micro)))

#endif /* UNIPICHANNEL_VERSION_H */
